/* dconf.c generated by valac 0.48.19, the Vala compiler
 * generated from dconf.vala, do not modify */

/*
 * Copyright © 2010, 2011 Codethink Limited
 * Copyright © 2011 Canonical Limited
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the licence, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Ryan Lortie <desrt@desrt.ca>
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "dconf.h"
#include <gio/gio.h>
#include <glib-object.h>
#include <locale.h>
#include <stdio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
typedef void (*Command) (gchar** args, gint args_length1, gpointer user_data, GError** error);

#define TYPE_COMMAND_MAPPING (command_mapping_get_type ())
typedef struct _CommandMapping CommandMapping;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _CommandMapping {
	Command func;
	gpointer func_target;
	GDestroyNotify func_target_destroy_notify;
	gchar* name;
};

void show_help (gboolean requested,
                const gchar* command);
void dconf_help (gchar** args,
                 gint args_length1,
                 GError** error);
void dconf_read (gchar** args,
                 gint args_length1,
                 GError** error);
void dconf_list (gchar** args,
                 gint args_length1,
                 GError** error);
void dconf_list_locks (gchar** args,
                       gint args_length1,
                       GError** error);
void dconf_write (gchar** args,
                  gint args_length1,
                  GError** error);
void dconf_reset (gchar** args,
                  gint args_length1,
                  GError** error);
void show_path (DConfClient* client,
                const gchar* path);
void watch_function (DConfClient* client,
                     const gchar* path,
                     gchar** items,
                     gint items_length1,
                     const gchar* tag);
void dconf_watch (gchar** args,
                  gint args_length1,
                  GError** error);
static void _watch_function_dconf_client_changed (DConfClient* _sender,
                                           const gchar* prefix,
                                           gchar** changes,
                                           const gchar* tag,
                                           gpointer self);
void dconf_blame (gchar** args,
                  gint args_length1,
                  GError** error);
void dconf_complete (gchar** args,
                     gint args_length1,
                     GError** error);
GType command_mapping_get_type (void) G_GNUC_CONST;
CommandMapping* command_mapping_dup (const CommandMapping* self);
void command_mapping_free (CommandMapping* self);
void command_mapping_copy (const CommandMapping* self,
                           CommandMapping* dest);
void command_mapping_destroy (CommandMapping* self);
void command_mapping_init (CommandMapping *self,
                           const gchar* name,
                           Command func,
                           gpointer func_target);
static gint _vala_main (gchar** args,
                 gint args_length1);
static void _dconf_help_command (gchar** args,
                          gint args_length1,
                          gpointer self,
                          GError** error);
static void _dconf_read_command (gchar** args,
                          gint args_length1,
                          gpointer self,
                          GError** error);
static void _dconf_list_command (gchar** args,
                          gint args_length1,
                          gpointer self,
                          GError** error);
static void _dconf_list_locks_command (gchar** args,
                                gint args_length1,
                                gpointer self,
                                GError** error);
static void _dconf_write_command (gchar** args,
                           gint args_length1,
                           gpointer self,
                           GError** error);
static void _dconf_reset_command (gchar** args,
                           gint args_length1,
                           gpointer self,
                           GError** error);
void dconf_compile (gchar** args,
                    gint args_length1,
                    GError** error);
static void _dconf_compile_command (gchar** args,
                             gint args_length1,
                             gpointer self,
                             GError** error);
void dconf_update (gchar** args,
                   gint args_length1,
                   GError** error);
static void _dconf_update_command (gchar** args,
                            gint args_length1,
                            gpointer self,
                            GError** error);
static void _dconf_watch_command (gchar** args,
                           gint args_length1,
                           gpointer self,
                           GError** error);
void dconf_dump (gchar** args,
                 gint args_length1,
                 GError** error);
static void _dconf_dump_command (gchar** args,
                          gint args_length1,
                          gpointer self,
                          GError** error);
void dconf_load (gchar** args,
                 gint args_length1,
                 GError** error);
static void _dconf_load_command (gchar** args,
                          gint args_length1,
                          gpointer self,
                          GError** error);
static void _dconf_blame_command (gchar** args,
                           gint args_length1,
                           gpointer self,
                           GError** error);
static void _dconf_complete_command (gchar** args,
                              gint args_length1,
                              gpointer self,
                              GError** error);
static void _vala_CommandMapping_array_free (CommandMapping * array,
                                      gint array_length);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

void
show_help (gboolean requested,
           const gchar* command)
{
	GString* str = NULL;
	GString* _tmp0_;
	gchar* description = NULL;
	gchar* synopsis = NULL;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	static GQuark _tmp2_label3 = 0;
	static GQuark _tmp2_label4 = 0;
	static GQuark _tmp2_label5 = 0;
	static GQuark _tmp2_label6 = 0;
	static GQuark _tmp2_label7 = 0;
	static GQuark _tmp2_label8 = 0;
	static GQuark _tmp2_label9 = 0;
	static GQuark _tmp2_label10 = 0;
	static GQuark _tmp2_label11 = 0;
	_tmp0_ = g_string_new ("");
	str = _tmp0_;
	description = NULL;
	synopsis = NULL;
	_tmp1_ = command;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string (NULL)))) {
		switch (0) {
			default:
			{
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("help")))) {
		switch (0) {
			default:
			{
				gchar* _tmp4_;
				gchar* _tmp5_;
				_tmp4_ = g_strdup ("Print help");
				_g_free0 (description);
				description = _tmp4_;
				_tmp5_ = g_strdup (" COMMAND ");
				_g_free0 (synopsis);
				synopsis = _tmp5_;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("read")))) {
		switch (0) {
			default:
			{
				gchar* _tmp6_;
				gchar* _tmp7_;
				_tmp6_ = g_strdup ("Read the value of a key.  -d to read default values.");
				_g_free0 (description);
				description = _tmp6_;
				_tmp7_ = g_strdup (" [-d] KEY ");
				_g_free0 (synopsis);
				synopsis = _tmp7_;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("list")))) {
		switch (0) {
			default:
			{
				gchar* _tmp8_;
				gchar* _tmp9_;
				_tmp8_ = g_strdup ("List the sub-keys and sub-dirs of a dir");
				_g_free0 (description);
				description = _tmp8_;
				_tmp9_ = g_strdup (" DIR ");
				_g_free0 (synopsis);
				synopsis = _tmp9_;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("list-locks")))) {
		switch (0) {
			default:
			{
				gchar* _tmp10_;
				gchar* _tmp11_;
				_tmp10_ = g_strdup ("List the locks under a dir");
				_g_free0 (description);
				description = _tmp10_;
				_tmp11_ = g_strdup (" DIR ");
				_g_free0 (synopsis);
				synopsis = _tmp11_;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("write")))) {
		switch (0) {
			default:
			{
				gchar* _tmp12_;
				gchar* _tmp13_;
				_tmp12_ = g_strdup ("Write a new value to a key");
				_g_free0 (description);
				description = _tmp12_;
				_tmp13_ = g_strdup (" KEY VALUE ");
				_g_free0 (synopsis);
				synopsis = _tmp13_;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("reset")))) {
		switch (0) {
			default:
			{
				gchar* _tmp14_;
				gchar* _tmp15_;
				_tmp14_ = g_strdup ("Reset a key or dir.  -f is required for dirs.");
				_g_free0 (description);
				description = _tmp14_;
				_tmp15_ = g_strdup (" [-f] PATH ");
				_g_free0 (synopsis);
				synopsis = _tmp15_;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("compile")))) {
		switch (0) {
			default:
			{
				gchar* _tmp16_;
				gchar* _tmp17_;
				_tmp16_ = g_strdup ("Compile a binary database from keyfiles");
				_g_free0 (description);
				description = _tmp16_;
				_tmp17_ = g_strdup (" OUTPUT KEYFILEDIR ");
				_g_free0 (synopsis);
				synopsis = _tmp17_;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("update")))) {
		switch (0) {
			default:
			{
				gchar* _tmp18_;
				gchar* _tmp19_;
				_tmp18_ = g_strdup ("Update the system dconf databases");
				_g_free0 (description);
				description = _tmp18_;
				_tmp19_ = g_strdup ("");
				_g_free0 (synopsis);
				synopsis = _tmp19_;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("watch")))) {
		switch (0) {
			default:
			{
				gchar* _tmp20_;
				gchar* _tmp21_;
				_tmp20_ = g_strdup ("Watch a path for key changes");
				_g_free0 (description);
				description = _tmp20_;
				_tmp21_ = g_strdup (" PATH ");
				_g_free0 (synopsis);
				synopsis = _tmp21_;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("dump")))) {
		switch (0) {
			default:
			{
				gchar* _tmp22_;
				gchar* _tmp23_;
				_tmp22_ = g_strdup ("Dump an entire subpath to stdout");
				_g_free0 (description);
				description = _tmp22_;
				_tmp23_ = g_strdup (" DIR ");
				_g_free0 (synopsis);
				synopsis = _tmp23_;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("load")))) {
		switch (0) {
			default:
			{
				gchar* _tmp24_;
				gchar* _tmp25_;
				_tmp24_ = g_strdup ("Populate a subpath from stdin");
				_g_free0 (description);
				description = _tmp24_;
				_tmp25_ = g_strdup (" DIR ");
				_g_free0 (synopsis);
				synopsis = _tmp25_;
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				GString* _tmp26_;
				_tmp26_ = str;
				g_string_append_printf (_tmp26_, "Unknown command '%s'\n\n", command);
				command = NULL;
				break;
			}
		}
	}
	if (command == NULL) {
		GString* _tmp27_;
		_tmp27_ = str;
		g_string_append (_tmp27_, "Usage:\n" \
"  dconf COMMAND [ARGS...]\n" \
"\n" \
"Commands:\n" \
"  help              Show this information\n" \
"  read              Read the value of a key\n" \
"  list              List the contents of a dir\n" \
"  write             Change the value of a key\n" \
"  reset             Reset the value of a key or dir\n" \
"  compile           Compile a binary database from keyfiles\n" \
"  update            Update the system databases\n" \
"  watch             Watch a path for changes\n" \
"  dump              Dump an entire subpath to stdout\n" \
"  load              Populate a subpath from stdin\n" \
"\n" \
"Use 'dconf help COMMAND' to get detailed help.\n" \
"\n");
	} else {
		GString* _tmp28_;
		GString* _tmp29_;
		const gchar* _tmp30_;
		GString* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		GString* _tmp53_;
		_tmp28_ = str;
		g_string_append (_tmp28_, "Usage:\n");
		_tmp29_ = str;
		_tmp30_ = synopsis;
		g_string_append_printf (_tmp29_, "  dconf %s%s\n\n", command, _tmp30_);
		_tmp31_ = str;
		_tmp32_ = description;
		g_string_append_printf (_tmp31_, "%s\n\n", _tmp32_);
		_tmp33_ = synopsis;
		if (g_strcmp0 (_tmp33_, "") != 0) {
			GString* _tmp34_;
			const gchar* _tmp35_;
			const gchar* _tmp37_;
			gboolean _tmp39_ = FALSE;
			const gchar* _tmp40_;
			gboolean _tmp43_ = FALSE;
			const gchar* _tmp44_;
			const gchar* _tmp47_;
			const gchar* _tmp49_;
			const gchar* _tmp51_;
			_tmp34_ = str;
			g_string_append (_tmp34_, "Arguments:\n");
			_tmp35_ = synopsis;
			if (string_contains (_tmp35_, " COMMAND ")) {
				GString* _tmp36_;
				_tmp36_ = str;
				g_string_append (_tmp36_, "  COMMAND     The (optional) command to explain\n");
			}
			_tmp37_ = synopsis;
			if (string_contains (_tmp37_, " PATH ")) {
				GString* _tmp38_;
				_tmp38_ = str;
				g_string_append (_tmp38_, "  PATH        Either a KEY or DIR\n");
			}
			_tmp40_ = synopsis;
			if (string_contains (_tmp40_, " PATH ")) {
				_tmp39_ = TRUE;
			} else {
				const gchar* _tmp41_;
				_tmp41_ = synopsis;
				_tmp39_ = string_contains (_tmp41_, " KEY ");
			}
			if (_tmp39_) {
				GString* _tmp42_;
				_tmp42_ = str;
				g_string_append (_tmp42_, "  KEY         A key path (starting, but not ending with '/')\n");
			}
			_tmp44_ = synopsis;
			if (string_contains (_tmp44_, " PATH ")) {
				_tmp43_ = TRUE;
			} else {
				const gchar* _tmp45_;
				_tmp45_ = synopsis;
				_tmp43_ = string_contains (_tmp45_, " DIR ");
			}
			if (_tmp43_) {
				GString* _tmp46_;
				_tmp46_ = str;
				g_string_append (_tmp46_, "  DIR         A directory path (starting and ending with '/')\n");
			}
			_tmp47_ = synopsis;
			if (string_contains (_tmp47_, " VALUE ")) {
				GString* _tmp48_;
				_tmp48_ = str;
				g_string_append (_tmp48_, "  VALUE       The value to write (in GVariant format)\n");
			}
			_tmp49_ = synopsis;
			if (string_contains (_tmp49_, " OUTPUT ")) {
				GString* _tmp50_;
				_tmp50_ = str;
				g_string_append (_tmp50_, "  OUTPUT      The filename of the (binary) output\n");
			}
			_tmp51_ = synopsis;
			if (string_contains (_tmp51_, " KEYFILEDIR ")) {
				GString* _tmp52_;
				_tmp52_ = str;
				g_string_append (_tmp52_, "  KEYFILEDIR  The path to the .d directory containing keyfiles\n");
			}
		}
		_tmp53_ = str;
		g_string_append (_tmp53_, "\n");
	}
	if (requested) {
		GString* _tmp54_;
		const gchar* _tmp55_;
		_tmp54_ = str;
		_tmp55_ = _tmp54_->str;
		g_print ("%s", _tmp55_);
	} else {
		GString* _tmp56_;
		const gchar* _tmp57_;
		_tmp56_ = str;
		_tmp57_ = _tmp56_->str;
		g_printerr ("%s", _tmp57_);
	}
	_g_free0 (synopsis);
	_g_free0 (description);
	_g_string_free0 (str);
}

void
dconf_help (gchar** args,
            gint args_length1,
            GError** error)
{
	const gchar* _tmp0_;
	_tmp0_ = args[2];
	show_help (TRUE, _tmp0_);
}

void
dconf_read (gchar** args,
            gint args_length1,
            GError** error)
{
	DConfClient* client = NULL;
	DConfClient* _tmp0_;
	DConfReadFlags flags = 0;
	gint index = 0;
	const gchar* _tmp1_;
	gchar* key = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GVariant* _result_ = NULL;
	DConfClient* _tmp5_;
	DConfReadFlags _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = dconf_client_new ();
	client = _tmp0_;
	flags = DCONF_READ_FLAGS_NONE;
	index = 2;
	_tmp1_ = args[index];
	if (g_strcmp0 (_tmp1_, "-d") == 0) {
		gint _tmp2_;
		flags = DCONF_READ_DEFAULT_VALUE;
		_tmp2_ = index;
		index = _tmp2_ + 1;
	}
	_tmp3_ = args[index];
	_tmp4_ = g_strdup (_tmp3_);
	key = _tmp4_;
	dconf_is_key (key, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (key);
		_g_object_unref0 (client);
		return;
	}
	_tmp5_ = client;
	_tmp6_ = flags;
	_tmp7_ = dconf_client_read_full (_tmp5_, key, _tmp6_, NULL);
	_result_ = _tmp7_;
	_tmp8_ = _result_;
	if (_tmp8_ != NULL) {
		GVariant* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		_tmp9_ = _result_;
		_tmp10_ = g_variant_print (_tmp9_, TRUE);
		_tmp11_ = _tmp10_;
		g_print ("%s\n", _tmp11_);
		_g_free0 (_tmp11_);
	}
	_g_variant_unref0 (_result_);
	_g_free0 (key);
	_g_object_unref0 (client);
}

void
dconf_list (gchar** args,
            gint args_length1,
            GError** error)
{
	DConfClient* client = NULL;
	DConfClient* _tmp0_;
	gchar* dir = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = dconf_client_new ();
	client = _tmp0_;
	_tmp1_ = args[2];
	_tmp2_ = g_strdup (_tmp1_);
	dir = _tmp2_;
	dconf_is_dir (dir, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (dir);
		_g_object_unref0 (client);
		return;
	}
	_tmp4_ = dconf_client_list (client, dir, &_tmp3_);
	{
		gchar** item_collection = NULL;
		gint item_collection_length1 = 0;
		gint _item_collection_size_ = 0;
		gint item_it = 0;
		item_collection = _tmp4_;
		item_collection_length1 = _tmp3_;
		for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
			gchar* _tmp5_;
			gchar* item = NULL;
			_tmp5_ = g_strdup (item_collection[item_it]);
			item = _tmp5_;
			{
				const gchar* _tmp6_;
				_tmp6_ = item;
				g_print ("%s\n", _tmp6_);
				_g_free0 (item);
			}
		}
		item_collection = (_vala_array_free (item_collection, item_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_g_free0 (dir);
	_g_object_unref0 (client);
}

void
dconf_list_locks (gchar** args,
                  gint args_length1,
                  GError** error)
{
	DConfClient* client = NULL;
	DConfClient* _tmp0_;
	gchar* dir = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = dconf_client_new ();
	client = _tmp0_;
	_tmp1_ = args[2];
	_tmp2_ = g_strdup (_tmp1_);
	dir = _tmp2_;
	dconf_is_dir (dir, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (dir);
		_g_object_unref0 (client);
		return;
	}
	_tmp4_ = dconf_client_list_locks (client, dir, &_tmp3_);
	{
		gchar** item_collection = NULL;
		gint item_collection_length1 = 0;
		gint _item_collection_size_ = 0;
		gint item_it = 0;
		item_collection = _tmp4_;
		item_collection_length1 = _tmp3_;
		for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
			gchar* _tmp5_;
			gchar* item = NULL;
			_tmp5_ = g_strdup (item_collection[item_it]);
			item = _tmp5_;
			{
				const gchar* _tmp6_;
				_tmp6_ = item;
				g_print ("%s\n", _tmp6_);
				_g_free0 (item);
			}
		}
		item_collection = (_vala_array_free (item_collection, item_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_g_free0 (dir);
	_g_object_unref0 (client);
}

void
dconf_write (gchar** args,
             gint args_length1,
             GError** error)
{
	DConfClient* client = NULL;
	DConfClient* _tmp0_;
	gchar* key = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* val = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	GVariant* _tmp6_ = NULL;
	const gchar* _tmp7_;
	GVariant* _tmp8_;
	DConfClient* _tmp9_;
	const gchar* _tmp10_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = dconf_client_new ();
	client = _tmp0_;
	_tmp1_ = args[2];
	_tmp2_ = g_strdup (_tmp1_);
	key = _tmp2_;
	_tmp3_ = args[3];
	_tmp4_ = g_strdup (_tmp3_);
	val = _tmp4_;
	_tmp5_ = key;
	dconf_is_key (_tmp5_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (val);
		_g_free0 (key);
		_g_object_unref0 (client);
		return;
	}
	_tmp7_ = val;
	_tmp8_ = g_variant_parse (NULL, _tmp7_, NULL, NULL, &_inner_error0_);
	_tmp6_ = _tmp8_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (val);
		_g_free0 (key);
		_g_object_unref0 (client);
		return;
	}
	_tmp9_ = client;
	_tmp10_ = key;
	dconf_client_write_sync (_tmp9_, _tmp10_, _tmp6_, NULL, NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_variant_unref0 (_tmp6_);
		_g_free0 (val);
		_g_free0 (key);
		_g_object_unref0 (client);
		return;
	}
	_g_variant_unref0 (_tmp6_);
	_g_free0 (val);
	_g_free0 (key);
	_g_object_unref0 (client);
}

void
dconf_reset (gchar** args,
             gint args_length1,
             GError** error)
{
	DConfClient* client = NULL;
	DConfClient* _tmp0_;
	gboolean force = FALSE;
	gint index = 0;
	const gchar* _tmp1_;
	gchar* path = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	DConfClient* _tmp9_;
	const gchar* _tmp10_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = dconf_client_new ();
	client = _tmp0_;
	force = FALSE;
	index = 2;
	_tmp1_ = args[index];
	if (g_strcmp0 (_tmp1_, "-f") == 0) {
		gint _tmp2_;
		force = TRUE;
		_tmp2_ = index;
		index = _tmp2_ + 1;
	}
	_tmp3_ = args[index];
	_tmp4_ = g_strdup (_tmp3_);
	path = _tmp4_;
	_tmp5_ = path;
	dconf_is_path (_tmp5_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (path);
		_g_object_unref0 (client);
		return;
	}
	_tmp7_ = path;
	if (dconf_is_dir (_tmp7_, NULL)) {
		_tmp6_ = !force;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		GError* _tmp8_;
		_tmp8_ = g_error_new_literal (G_OPTION_ERROR, G_OPTION_ERROR_FAILED, "-f must be given to (recursively) reset entire dirs");
		_inner_error0_ = _tmp8_;
		g_propagate_error (error, _inner_error0_);
		_g_free0 (path);
		_g_object_unref0 (client);
		return;
	}
	_tmp9_ = client;
	_tmp10_ = path;
	dconf_client_write_sync (_tmp9_, _tmp10_, NULL, NULL, NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (path);
		_g_object_unref0 (client);
		return;
	}
	_g_free0 (path);
	_g_object_unref0 (client);
}

void
show_path (DConfClient* client,
           const gchar* path)
{
	g_return_if_fail (client != NULL);
	g_return_if_fail (path != NULL);
	if (dconf_is_key (path, NULL)) {
		GVariant* value = NULL;
		GVariant* _tmp0_;
		gchar* _tmp1_ = NULL;
		GVariant* _tmp2_;
		_tmp0_ = dconf_client_read (client, path);
		value = _tmp0_;
		_tmp2_ = value;
		if (_tmp2_ != NULL) {
			GVariant* _tmp3_;
			gchar* _tmp4_;
			_tmp3_ = value;
			_tmp4_ = g_variant_print (_tmp3_, TRUE);
			_g_free0 (_tmp1_);
			_tmp1_ = _tmp4_;
		} else {
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("unset");
			_g_free0 (_tmp1_);
			_tmp1_ = _tmp5_;
		}
		g_print ("  %s\n", _tmp1_);
		_g_free0 (_tmp1_);
		_g_variant_unref0 (value);
	}
}

void
watch_function (DConfClient* client,
                const gchar* path,
                gchar** items,
                gint items_length1,
                const gchar* tag)
{
	g_return_if_fail (client != NULL);
	g_return_if_fail (path != NULL);
	{
		gchar** item_collection = NULL;
		gint item_collection_length1 = 0;
		gint _item_collection_size_ = 0;
		gint item_it = 0;
		item_collection = items;
		item_collection_length1 = items_length1;
		for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
			gchar* _tmp0_;
			gchar* item = NULL;
			_tmp0_ = g_strdup (item_collection[item_it]);
			item = _tmp0_;
			{
				gchar* full = NULL;
				const gchar* _tmp1_;
				gchar* _tmp2_;
				const gchar* _tmp3_;
				const gchar* _tmp4_;
				_tmp1_ = item;
				_tmp2_ = g_strconcat (path, _tmp1_, NULL);
				full = _tmp2_;
				_tmp3_ = full;
				g_print ("%s\n", _tmp3_);
				_tmp4_ = full;
				show_path (client, _tmp4_);
				_g_free0 (full);
				_g_free0 (item);
			}
		}
	}
	g_print ("\n");
}

static void
_watch_function_dconf_client_changed (DConfClient* _sender,
                                      const gchar* prefix,
                                      gchar** changes,
                                      const gchar* tag,
                                      gpointer self)
{
	watch_function (_sender, prefix, changes, _vala_array_length (changes), tag);
}

void
dconf_watch (gchar** args,
             gint args_length1,
             GError** error)
{
	DConfClient* client = NULL;
	DConfClient* _tmp0_;
	gchar* path = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GMainLoop* _tmp3_;
	GMainLoop* _tmp4_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = dconf_client_new ();
	client = _tmp0_;
	_tmp1_ = args[2];
	_tmp2_ = g_strdup (_tmp1_);
	path = _tmp2_;
	dconf_is_path (path, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (path);
		_g_object_unref0 (client);
		return;
	}
	g_signal_connect (client, "changed", (GCallback) _watch_function_dconf_client_changed, NULL);
	dconf_client_watch_sync (client, path);
	_tmp3_ = g_main_loop_new (NULL, FALSE);
	_tmp4_ = _tmp3_;
	g_main_loop_run (_tmp4_);
	_g_main_loop_unref0 (_tmp4_);
	_g_free0 (path);
	_g_object_unref0 (client);
}

void
dconf_blame (gchar** args,
             gint args_length1,
             GError** error)
{
	GDBusConnection* connection = NULL;
	GDBusConnection* _tmp0_;
	GVariant* reply = NULL;
	GDBusConnection* _tmp1_;
	GVariantType* _tmp2_;
	GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	const gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &_inner_error0_);
	connection = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
	_tmp1_ = connection;
	_tmp2_ = g_variant_type_new ("(s)");
	_tmp3_ = _tmp2_;
	_tmp4_ = g_dbus_connection_call_sync (_tmp1_, "ca.desrt.dconf", "/ca/desrt/dconf", "ca.desrt.dconf.ServiceInfo", "Blame", NULL, _tmp3_, G_DBUS_CALL_FLAGS_NONE, -1, NULL, &_inner_error0_);
	_tmp5_ = _tmp4_;
	_g_variant_type_free0 (_tmp3_);
	reply = _tmp5_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (connection);
		return;
	}
	_tmp6_ = reply;
	_tmp7_ = g_variant_get_child_value (_tmp6_, (gsize) 0);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_variant_get_string (_tmp8_, NULL);
	g_print ("%s", _tmp9_);
	_g_variant_unref0 (_tmp8_);
	_g_variant_unref0 (reply);
	_g_object_unref0 (connection);
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

void
dconf_complete (gchar** args,
                gint args_length1,
                GError** error)
{
	gchar* suffix = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* path = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	_tmp0_ = args[2];
	_tmp1_ = g_strdup (_tmp0_);
	suffix = _tmp1_;
	_tmp2_ = args[3];
	_tmp3_ = g_strdup (_tmp2_);
	path = _tmp3_;
	_tmp4_ = path;
	if (g_strcmp0 (_tmp4_, "") == 0) {
		g_print ("/\n");
		_g_free0 (path);
		_g_free0 (suffix);
		return;
	}
	_tmp5_ = path;
	if (string_get (_tmp5_, (glong) 0) == '/') {
		DConfClient* client = NULL;
		DConfClient* _tmp6_;
		gint last = 0;
		gchar* dir = NULL;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		DConfClient* _tmp13_;
		const gchar* _tmp14_;
		gint _tmp15_ = 0;
		gchar** _tmp16_;
		_tmp6_ = dconf_client_new ();
		client = _tmp6_;
		last = 0;
		{
			gint i = 0;
			i = 1;
			{
				gboolean _tmp7_ = FALSE;
				_tmp7_ = TRUE;
				while (TRUE) {
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					if (!_tmp7_) {
						gint _tmp8_;
						_tmp8_ = i;
						i = _tmp8_ + 1;
					}
					_tmp7_ = FALSE;
					_tmp9_ = path;
					if (!(string_get (_tmp9_, (glong) i) != '\0')) {
						break;
					}
					_tmp10_ = path;
					if (string_get (_tmp10_, (glong) i) == '/') {
						last = i;
					}
				}
			}
		}
		_tmp11_ = path;
		_tmp12_ = string_substring (_tmp11_, (glong) 0, (glong) (last + 1));
		dir = _tmp12_;
		_tmp13_ = client;
		_tmp14_ = dir;
		_tmp16_ = dconf_client_list (_tmp13_, _tmp14_, &_tmp15_);
		{
			gchar** item_collection = NULL;
			gint item_collection_length1 = 0;
			gint _item_collection_size_ = 0;
			gint item_it = 0;
			item_collection = _tmp16_;
			item_collection_length1 = _tmp15_;
			for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
				gchar* _tmp17_;
				gchar* item = NULL;
				_tmp17_ = g_strdup (item_collection[item_it]);
				item = _tmp17_;
				{
					gchar* full_item = NULL;
					const gchar* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
					gboolean _tmp21_ = FALSE;
					const gchar* _tmp22_;
					const gchar* _tmp23_;
					_tmp18_ = dir;
					_tmp19_ = item;
					_tmp20_ = g_strconcat (_tmp18_, _tmp19_, NULL);
					full_item = _tmp20_;
					_tmp22_ = full_item;
					_tmp23_ = path;
					if (g_str_has_prefix (_tmp22_, _tmp23_)) {
						const gchar* _tmp24_;
						const gchar* _tmp25_;
						_tmp24_ = item;
						_tmp25_ = suffix;
						_tmp21_ = g_str_has_suffix (_tmp24_, _tmp25_);
					} else {
						_tmp21_ = FALSE;
					}
					if (_tmp21_) {
						const gchar* _tmp26_ = NULL;
						const gchar* _tmp27_;
						const gchar* _tmp28_;
						_tmp27_ = full_item;
						if (g_str_has_suffix (_tmp27_, "/")) {
							_tmp26_ = "";
						} else {
							_tmp26_ = " ";
						}
						_tmp28_ = full_item;
						g_print ("%s%s\n", _tmp28_, _tmp26_);
					}
					_g_free0 (full_item);
					_g_free0 (item);
				}
			}
			item_collection = (_vala_array_free (item_collection, item_collection_length1, (GDestroyNotify) g_free), NULL);
		}
		_g_free0 (dir);
		_g_object_unref0 (client);
	}
	_g_free0 (path);
	_g_free0 (suffix);
}

void
command_mapping_init (CommandMapping *self,
                      const gchar* name,
                      Command func,
                      gpointer func_target)
{
	gchar* _tmp0_;
	g_return_if_fail (name != NULL);
	memset (self, 0, sizeof (CommandMapping));
	_tmp0_ = g_strdup (name);
	_g_free0 ((*self).name);
	(*self).name = _tmp0_;
	((*self).func_target_destroy_notify == NULL) ? NULL : ((*self).func_target_destroy_notify ((*self).func_target), NULL);
	(*self).func = NULL;
	(*self).func_target = NULL;
	(*self).func_target_destroy_notify = NULL;
	(*self).func = func;
	(*self).func_target = func_target;
	(*self).func_target_destroy_notify = NULL;
}

void
command_mapping_copy (const CommandMapping* self,
                      CommandMapping* dest)
{
	Command _tmp0_;
	gpointer _tmp0__target;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	_tmp0_ = (*self).func;
	_tmp0__target = (*self).func_target;
	((*dest).func_target_destroy_notify == NULL) ? NULL : ((*dest).func_target_destroy_notify ((*dest).func_target), NULL);
	(*dest).func = NULL;
	(*dest).func_target = NULL;
	(*dest).func_target_destroy_notify = NULL;
	(*dest).func = _tmp0_;
	(*dest).func_target = _tmp0__target;
	(*dest).func_target_destroy_notify = NULL;
	_tmp1_ = (*self).name;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp2_;
}

void
command_mapping_destroy (CommandMapping* self)
{
	((*self).func_target_destroy_notify == NULL) ? NULL : ((*self).func_target_destroy_notify ((*self).func_target), NULL);
	(*self).func = NULL;
	(*self).func_target = NULL;
	(*self).func_target_destroy_notify = NULL;
	_g_free0 ((*self).name);
}

CommandMapping*
command_mapping_dup (const CommandMapping* self)
{
	CommandMapping* dup;
	dup = g_new0 (CommandMapping, 1);
	command_mapping_copy (self, dup);
	return dup;
}

void
command_mapping_free (CommandMapping* self)
{
	command_mapping_destroy (self);
	g_free (self);
}

static GType
command_mapping_get_type_once (void)
{
	GType command_mapping_type_id;
	command_mapping_type_id = g_boxed_type_register_static ("CommandMapping", (GBoxedCopyFunc) command_mapping_dup, (GBoxedFreeFunc) command_mapping_free);
	return command_mapping_type_id;
}

GType
command_mapping_get_type (void)
{
	static volatile gsize command_mapping_type_id__volatile = 0;
	if (g_once_init_enter (&command_mapping_type_id__volatile)) {
		GType command_mapping_type_id;
		command_mapping_type_id = command_mapping_get_type_once ();
		g_once_init_leave (&command_mapping_type_id__volatile, command_mapping_type_id);
	}
	return command_mapping_type_id__volatile;
}

static void
_dconf_help_command (gchar** args,
                     gint args_length1,
                     gpointer self,
                     GError** error)
{
	dconf_help (args, args_length1, error);
}

static void
_dconf_read_command (gchar** args,
                     gint args_length1,
                     gpointer self,
                     GError** error)
{
	dconf_read (args, args_length1, error);
}

static void
_dconf_list_command (gchar** args,
                     gint args_length1,
                     gpointer self,
                     GError** error)
{
	dconf_list (args, args_length1, error);
}

static void
_dconf_list_locks_command (gchar** args,
                           gint args_length1,
                           gpointer self,
                           GError** error)
{
	dconf_list_locks (args, args_length1, error);
}

static void
_dconf_write_command (gchar** args,
                      gint args_length1,
                      gpointer self,
                      GError** error)
{
	dconf_write (args, args_length1, error);
}

static void
_dconf_reset_command (gchar** args,
                      gint args_length1,
                      gpointer self,
                      GError** error)
{
	dconf_reset (args, args_length1, error);
}

static void
_dconf_compile_command (gchar** args,
                        gint args_length1,
                        gpointer self,
                        GError** error)
{
	dconf_compile (args, args_length1, error);
}

static void
_dconf_update_command (gchar** args,
                       gint args_length1,
                       gpointer self,
                       GError** error)
{
	dconf_update (args, args_length1, error);
}

static void
_dconf_watch_command (gchar** args,
                      gint args_length1,
                      gpointer self,
                      GError** error)
{
	dconf_watch (args, args_length1, error);
}

static void
_dconf_dump_command (gchar** args,
                     gint args_length1,
                     gpointer self,
                     GError** error)
{
	dconf_dump (args, args_length1, error);
}

static void
_dconf_load_command (gchar** args,
                     gint args_length1,
                     gpointer self,
                     GError** error)
{
	dconf_load (args, args_length1, error);
}

static void
_dconf_blame_command (gchar** args,
                      gint args_length1,
                      gpointer self,
                      GError** error)
{
	dconf_blame (args, args_length1, error);
}

static void
_dconf_complete_command (gchar** args,
                         gint args_length1,
                         gpointer self,
                         GError** error)
{
	dconf_complete (args, args_length1, error);
}

static void
_vala_CommandMapping_array_free (CommandMapping * array,
                                 gint array_length)
{
	if (array != NULL) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			command_mapping_destroy (&array[i]);
		}
	}
	g_free (array);
}

static gint
_vala_main (gchar** args,
            gint args_length1)
{
	const gchar* _tmp0_;
	CommandMapping* map = NULL;
	CommandMapping _tmp1_ = {0};
	CommandMapping _tmp2_ = {0};
	CommandMapping _tmp3_ = {0};
	CommandMapping _tmp4_ = {0};
	CommandMapping _tmp5_ = {0};
	CommandMapping _tmp6_ = {0};
	CommandMapping _tmp7_ = {0};
	CommandMapping _tmp8_ = {0};
	CommandMapping _tmp9_ = {0};
	CommandMapping _tmp10_ = {0};
	CommandMapping _tmp11_ = {0};
	CommandMapping _tmp12_ = {0};
	CommandMapping _tmp13_ = {0};
	CommandMapping* _tmp14_;
	gint map_length1;
	gint _map_size_;
	gint _tmp31_ = -1;
	GError* _inner_error0_ = NULL;
	gint result = 0;
	_vala_assert (args_length1 != 0, "args.length != 0");
	_tmp0_ = args[0];
	g_set_prgname (_tmp0_);
	setlocale (LC_ALL, "");
	command_mapping_init (&_tmp1_, "help", _dconf_help_command, NULL);
	command_mapping_init (&_tmp2_, "read", _dconf_read_command, NULL);
	command_mapping_init (&_tmp3_, "list", _dconf_list_command, NULL);
	command_mapping_init (&_tmp4_, "list-locks", _dconf_list_locks_command, NULL);
	command_mapping_init (&_tmp5_, "write", _dconf_write_command, NULL);
	command_mapping_init (&_tmp6_, "reset", _dconf_reset_command, NULL);
	command_mapping_init (&_tmp7_, "compile", _dconf_compile_command, NULL);
	command_mapping_init (&_tmp8_, "update", _dconf_update_command, NULL);
	command_mapping_init (&_tmp9_, "watch", _dconf_watch_command, NULL);
	command_mapping_init (&_tmp10_, "dump", _dconf_dump_command, NULL);
	command_mapping_init (&_tmp11_, "load", _dconf_load_command, NULL);
	command_mapping_init (&_tmp12_, "blame", _dconf_blame_command, NULL);
	command_mapping_init (&_tmp13_, "_complete", _dconf_complete_command, NULL);
	_tmp14_ = g_new0 (CommandMapping, 13);
	_tmp14_[0] = _tmp1_;
	_tmp14_[1] = _tmp2_;
	_tmp14_[2] = _tmp3_;
	_tmp14_[3] = _tmp4_;
	_tmp14_[4] = _tmp5_;
	_tmp14_[5] = _tmp6_;
	_tmp14_[6] = _tmp7_;
	_tmp14_[7] = _tmp8_;
	_tmp14_[8] = _tmp9_;
	_tmp14_[9] = _tmp10_;
	_tmp14_[10] = _tmp11_;
	_tmp14_[11] = _tmp12_;
	_tmp14_[12] = _tmp13_;
	map = _tmp14_;
	map_length1 = 13;
	_map_size_ = map_length1;
	{
		const gchar* _tmp15_;
		CommandMapping* _tmp17_;
		gint _tmp17__length1;
		const gchar* _tmp25_;
		GError* _tmp26_;
		_tmp15_ = args[1];
		if (_tmp15_ == NULL) {
			GError* _tmp16_;
			_tmp16_ = g_error_new_literal (G_OPTION_ERROR, G_OPTION_ERROR_FAILED, "no command specified");
			_inner_error0_ = _tmp16_;
			goto __catch0_g_error;
		}
		_tmp17_ = map;
		_tmp17__length1 = map_length1;
		{
			CommandMapping* mapping_collection = NULL;
			gint mapping_collection_length1 = 0;
			gint _mapping_collection_size_ = 0;
			gint mapping_it = 0;
			mapping_collection = _tmp17_;
			mapping_collection_length1 = _tmp17__length1;
			for (mapping_it = 0; mapping_it < mapping_collection_length1; mapping_it = mapping_it + 1) {
				CommandMapping _tmp18_;
				CommandMapping _tmp19_ = {0};
				CommandMapping mapping = {0};
				_tmp18_ = mapping_collection[mapping_it];
				command_mapping_copy (&_tmp18_, &_tmp19_);
				mapping = _tmp19_;
				{
					CommandMapping _tmp20_;
					const gchar* _tmp21_;
					const gchar* _tmp22_;
					_tmp20_ = mapping;
					_tmp21_ = _tmp20_.name;
					_tmp22_ = args[1];
					if (g_strcmp0 (_tmp21_, _tmp22_) == 0) {
						CommandMapping _tmp23_;
						Command _tmp24_;
						gpointer _tmp24__target;
						_tmp23_ = mapping;
						_tmp24_ = _tmp23_.func;
						_tmp24__target = _tmp23_.func_target;
						_tmp24_ (args, (gint) args_length1, _tmp24__target, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							command_mapping_destroy (&mapping);
							goto __catch0_g_error;
						}
						result = 0;
						command_mapping_destroy (&mapping);
						map = (_vala_CommandMapping_array_free (map, map_length1), NULL);
						return result;
					}
					command_mapping_destroy (&mapping);
				}
			}
		}
		_tmp25_ = args[1];
		_tmp26_ = g_error_new (G_OPTION_ERROR, G_OPTION_ERROR_FAILED, "unknown command %s", _tmp25_);
		_inner_error0_ = _tmp26_;
		goto __catch0_g_error;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp27_;
		GError* _tmp28_;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp27_ = stderr;
		_tmp28_ = e;
		_tmp29_ = _tmp28_->message;
		fprintf (_tmp27_, "error: %s\n\n", _tmp29_);
		_tmp30_ = args[1];
		show_help (FALSE, _tmp30_);
		result = 1;
		_g_error_free0 (e);
		map = (_vala_CommandMapping_array_free (map, map_length1), NULL);
		return result;
	}
	__finally0:
	map = (_vala_CommandMapping_array_free (map, map_length1), NULL);
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return _tmp31_;
}

int
main (int argc,
      char ** argv)
{
	return _vala_main (argv, argc);
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

